searchNodes=[{"doc":"Generates the mix task for running CI checks.","ref":"Mix.Tasks.Ci.Init.html","title":"Mix.Tasks.Ci.Init","type":"task"},{"doc":"Managed execution of external commands.This module provides similar functionality to System.cmd/3, with the difference that the execution of commands is managed, which provides the following benefits:The external OS process is logically linked to the parent BEAM process (the process which started it). If the parent process terminates, the OS process will be taken down.The external OS process will also be taken down if the entire BEAM instance goes down.Support for timeout-based and manual termination of the OS process.Polite-first termination of the OS process (SIGTERM followed by SIGKILL) in the spirit of OTP termination (shutdown strategies).In this regard, OsCmd is similar to erlexec and porcelain, though it doesn't have all the features of those projects.For usage details, see start_link/1.","ref":"OsCmd.html","title":"OsCmd","type":"module"},{"doc":"Returns a specification for running the command as a Job action.The corresponding action will return {:ok, output} | {:error, %OsCmdError{}} See Job.start_action/2 for details.","ref":"OsCmd.html#action/2","title":"OsCmd.action/2","type":"function"},{"doc":"Issues an explicit mock allowance to another process.Note that mocks are automatically inherited by descendants, so you only need to use this for non descendant processes. See Mox.allow/3 for details.","ref":"OsCmd.html#allow/1","title":"OsCmd.allow/1","type":"function"},{"doc":"Awaits for the started command to finish.This function is internally used by run/2. If you want to use it yourself, you need to pass the handler &amp;send(some_pid, {self(), &amp;1}) when starting the command. This function can only be invoked in the process which receives the event messages.","ref":"OsCmd.html#await/1","title":"OsCmd.await/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"OsCmd.html#child_spec/1","title":"OsCmd.child_spec/1","type":"function"},{"doc":"Returns a lazy stream of events.This function is internally used by run/2 and await/1. If you want to use it yourself, you need to pass the handler &amp;send(some_pid, {self(), &amp;1}) when starting the command. This function can only be invoked in the process which receives the event messages.","ref":"OsCmd.html#events/1","title":"OsCmd.events/1","type":"function"},{"doc":"Sets up a mock expectation.The argument can be either a string (the exact command text), or a function. If the string is passed, the mocked command will succeed with the empty output. If the function is passed, it will be invoked when the command is started. The function can then return ok or error tuple.The expectation will be inherited by all descendant processes (unless overridden somewhere down the process tree).See Mox.expect/4 for details on expectations.","ref":"OsCmd.html#expect/1","title":"OsCmd.expect/1","type":"function"},{"doc":"Synchronously runs the command.This function will start the owner process, wait for it to finish, and return the result which will include the complete output of the command.If the command exits with a zero exit status, an :ok tuple is returned. Otherwise, the function returns an error tuple.See start_link/1 for detailed explanation.","ref":"OsCmd.html#run/2","title":"OsCmd.run/2","type":"function"},{"doc":"Starts the command owner process.The owner process will start the command, handle its events, and stop when the command finishes. The started process will synchronously stop the command during while being terminated. The owner process never stops before the command finishes (unless the owner process is forcefully terminated with the reason :kill), which makes it safe to run under a supervisor or Parent.The command is a &quot;free-form string&quot; in the shape of: &quot;command arg1 arg2 ...&quot;. The command has to be an executable that exists in standard search paths.Args can be separated by one or more whitespaces, tabs, or newline characters. If any arg has to contain whitespace characters, you can encircle it in double or single quotes. Inside the quoted argument, you can use \\&quot; or \\' to inject the quote character, and \\\\ to inject the backslash character.Examples:OsCmd.start_link(&quot;echo 1&quot;)` OsCmd.start_link(~s/ some_cmd arg1 &quot;arg \\&quot; \\\\ 2&quot; &#39;arg \\&#39; \\\\ 3&#39; /)Due to support for free-form execution, it is possible to execute complex scripts, by starting the shell processOsCmd.start_link(~s/bash -c &quot;...&quot;/)However, this is usually not advised, because OsCmd can't keep all of its guarantees. Any child process started inside the shell is not guaranteed to be terminated before the owner process stops, and some of them might even linger on forever.OptionsYou can pass additional options by invoking OsCmd.start_link({cmd, opts}). The following options are supported::cd - Folder in which the command will be started:env- OS environment variables which will be set in the command's own environment. Note that the command OS process inherits the environment from the BEAM process. If you want to unset some of the inherited variables, you can include {var_to_unset, nil} in this list.:pty - If set to true, the command will be started with a pseudo-terminal interface. If the OS doesn't support pseudo-terminal, this flag is ignored. Defaults to false.:timeout - The duration after which the command will be automatically terminated. Defaults to :infinity. If the command is timed out, the process will exit with the reason :timeout, irrespective of the propagate_exit? setting.propagate_exit? - When set to true and the exit reason of the command is not zero, the process will exit with {:failed, exit_status}. Otherwise, the process will always exit with the reason :normal (unless the command times out).terminate_cmd - Custom command to use in place of SIGTERM when stopping the OS process. See the &quot;Command termination&quot; section for details.handler - Custom event handler. See the &quot;Event handling&quot; section for details.name - Registered name of the process. If not provided, the process won't be registered.Event handlingDuring the lifetime of the command, the following events are emitted::starting - the command is being started{:output, output} - stdout or stderr output{:stopped, exit_status} - the command stopped with the given exit statusYou can install multiple custom handlers to deal with these events. By default, no handler is created, which means that the command is executed silently. Handlers are functions which are executed inside the command owner process. Handlers can be stateless or stateful.A stateless handler is a function in the shape of fun(event) -&gt; ... end. This function holds no state, so its result is ignored. A stateful handler can be specified as {initial_acc, fun(event, acc) -&gt; next_acc end}. You can provide multiple handlers, and they don't have to be of the same type.Since handlers are executed in the owner process, an unhandled exception in the handler will lead to process termination. The OS process will be properly taken down before the owner process stops, but no additional event (including the :stopped event) will be fired.It is advised to minimize the logic inside handlers. Handlers are best suited for very simple tasks such as logging or notifying other processes.OutputThe output events will contain output fragments, as they are received. It is therefore possible that some fragment contains only a part of the output line, while another spans multiple lines. It is the responsibility of the client to assemble these fragments according to its needs.OsCmd operates on the assumption that output is in utf8 encoding, so it may not work correctly for other encodings, such as plain binary.Command terminationWhen command is being externally terminated (e.g. due to a timeout), a polite termination is first attempted, by sending a SIGTERM signal to the OS process (if the OS supports such signal), or alternatively invoking a custom terminated command provided via :terminate_cmd. If the OS process doesn't stop in 5 seconds (currently not configurable), a SIGKILL signal will be sent.InternalsThe owner process starts the command as the Erlang port. The command is not started directly. Instead a bridge program (implemented in go) is used to start and manage the OS process. Each command uses its own bridge process. This approach ensures proper cleanup guarantees even if the BEAM OS process is taken down.As a result, compared to System.cmd/3, OsCmd will consume more resources (2x more OS process instances) and require more hops to pass the output back to Elixir. Most often this won't matter, but be aware of these trade-offs if you're starting a large number of external processes.Mocking in testsCommand execution can be mocked, which may be useful if you want to avoid starting long-running commands in tests.Mocking can done with expect/1 and stub/1, and explicit allowances can be issued with allow/1.","ref":"OsCmd.html#start_link/1","title":"OsCmd.start_link/1","type":"function"},{"doc":"Stops the command and the owner process.","ref":"OsCmd.html#stop/2","title":"OsCmd.stop/2","type":"function"},{"doc":"Sets up a mock stub.This function works similarly to expect/1, except it sets up a stub. See Mox.stub/3 for details on stubs.","ref":"OsCmd.html#stub/1","title":"OsCmd.stub/1","type":"function"},{"doc":"","ref":"OsCmd.html#t:acc/0","title":"OsCmd.acc/0","type":"type"},{"doc":"","ref":"OsCmd.html#t:event/0","title":"OsCmd.event/0","type":"type"},{"doc":"","ref":"OsCmd.html#t:exit_status/0","title":"OsCmd.exit_status/0","type":"type"},{"doc":"","ref":"OsCmd.html#t:handler/0","title":"OsCmd.handler/0","type":"type"},{"doc":"","ref":"OsCmd.html#t:mock/0","title":"OsCmd.mock/0","type":"type"},{"doc":"","ref":"OsCmd.html#t:output/0","title":"OsCmd.output/0","type":"type"},{"doc":"","ref":"OsCmd.html#t:start_opt/0","title":"OsCmd.start_opt/0","type":"type"},{"doc":"Managed execution of potentially failing actions.A job is a logical unit of work which is split into multiple actions, where each action is running in its own separate process, which is a child of the job process.Basic sketchJob.start_link(fn -&gt; # this is the root action {:ok, action1} = Job.start_action(fn -&gt; # ... end) {:ok, action2} = Job.start_action(fn -&gt; result_of_action_3 = Job.run(fn -&gt; end) # ... end) {Job.await(action1), Job.await(action2)} end)Comparison to tasksJob is somewhat similar to Task, with the main difference that it manages the execution of its actions. The job process stops only after all of its actions have terminated, which is a guarantee not provided by Task.In addition, Job makes some different decisions. Most notably, a crash of an action is automatically converted into an error result, which simplifies the implementation of custom crash logic (e.g. error reporting).If slight asynchronism during termination can be tolerated, and there's no need to implement custom crash logic, Task is likely a better option.ActionsEach job runs one or more actions, which are technically child processes of the job process. A job is started with the root action. When the root action stops, the job process will also stop with the same exit reason. This is the only case where Job propagates a process exit.In its simplest form, an action can be a zero-arity function or an MFA tuple. In both cases, the action process will be powered by Task. You can also power the action process by your own module. See &quot;Custom action processes&quot; for details.Each action can start additional actions. Logically, such action is treated as the child of the action which started it. If the parent action terminates, its children will also be taken down.Technically every action process will be running as a direct child of the job process. This decision is made to simplify the process tree and reduce the amount of running processes.You can start additional actions with start_action/2 or run_action/2. If start_action/2 is used, the action result can be awaited on with await/1. These functions may only be invoked inside an action process.In case of Task-powered jobs, the action result is the return value of the invoked function. If the action process crashes, the result will be {:exit, exit_reason}. To avoid ambiguity, it is recommended to return ok/error tuples from the actions.Custom action processesTo power the action by a custom logic (e.g. GenServer), you need to provide the action spec factory function to start_action/2 or run_action/2:Job.start_action( fn responder -&gt; child_spec(responder) end )The factory function takes the responder, which is an arity one anonymous function. The function should return a child specification (Parent.start_spec/0) which describes how to start the action process.The action process needs to invoke responder.(action_response) to send the response back to its caller. This function may only be invoked inside the action process. As soon as this function is invoked, the action process must stop with the reason :normal.If the action process is stopping with an abnormal exit reason, it shouldn't invoke the responder function. Doing this will lead to duplicate response message in the mailbox of the parent action.For example of custom actions, see OsCmd and Job.Pipeline.InternalsThe job process is powered by Parent, with all actions running as its children. Logical hierarchy (parent-child relationship between actions) is modeled via bound siblings feature of Parent.","ref":"Job.html","title":"Job","type":"module"},{"doc":"Awaits for the job or the action response.This function must be invoked in the process which receives the response message. In the case of the job, this is the process specified with the :respond_to start option. When awaiting on the action, this is the logical parent action (i.e. the process that started the action).This function will await indefinitely. There's no support for client-side timeout. Instead, you can use the :timeout action option to limit the duration of an action.If the awaited job or action crashes, the response will be {:exit, exit_reason}. To avoid ambiguity, it is recommended to return ok/error tuples from each action.","ref":"Job.html#await/1","title":"Job.await/1","type":"function"},{"doc":"Returns a child specification for inserting a job into the supervision tree.","ref":"Job.html#child_spec/1","title":"Job.child_spec/1","type":"function"},{"doc":"Starts the job with start_link/2, and awaits for it with await/1.","ref":"Job.html#run/2","title":"Job.run/2","type":"function"},{"doc":"Starts a child action and awaits for its response.","ref":"Job.html#run_action/2","title":"Job.run_action/2","type":"function"},{"doc":"Starts a child action.See module documentation for details on action specification.The started action process will logically be treated as the child of the caller process. If the caller process terminates, the started process will be taken down as well.Unlike the root action, a child action always sends response to its caller. You can await this response with await/1.This function can only be invoked inside an action process.Options:timeout - Maximum duration of the action. If the action exceeds the given duration, it will be forcefully taken down. Defaults to :infinity.:telemetry_id - If provided, telemetry start and stop events will be emitted. This option must be a list. Job will append :start and :stop atoms to this list to emit the events.:telemetry_meta - Additional metadata to send with telemetry events. If not provided, an empty map is used.","ref":"Job.html#start_action/2","title":"Job.start_action/2","type":"function"},{"doc":"Starts the job process and the root action.Options:respond_to - a pid of the process that will receive the result of the root action. The target process can await on the result with await/1. If this option is not provided, the response will not be sent.name - Registered name of the process. If not provided, the process won't be registered.action option - see start_action/2 for details.","ref":"Job.html#start_link/2","title":"Job.start_link/2","type":"function"},{"doc":"","ref":"Job.html#t:action/0","title":"Job.action/0","type":"type"},{"doc":"","ref":"Job.html#t:action_fun_or_mfa/0","title":"Job.action_fun_or_mfa/0","type":"type"},{"doc":"","ref":"Job.html#t:action_opt/0","title":"Job.action_opt/0","type":"type"},{"doc":"","ref":"Job.html#t:responder/0","title":"Job.responder/0","type":"type"},{"doc":"","ref":"Job.html#t:response/0","title":"Job.response/0","type":"type"},{"doc":"","ref":"Job.html#t:start_opt/0","title":"Job.start_opt/0","type":"type"},{"doc":"High-level interface for running Job-powered pipeline of actions.A pipeline is a collection of actions which can be executed in sequence or parallel, and which all have to succeed for the job to succeed.ExampleJob.run( Pipeline.sequence([ action_1, action_2, Pipeline.parallel([action_3, action_4]), action_5 ]) )Such pipeline can be visually represented as: -&gt; action_3 action_1 -&gt; action_2 -&gt; action_5 -&gt; action_4An action inside a pipeline can be any Job.action/0 that responds with {:ok, result} | {:error, reason}. Other responses are not supported. An action crash will be converted into an {:error, exit_reason} response.A pipeline succeeds if all of its action succeed. In such case, the response of the pipeline is the list of responses of each action. For the example above, the successful response will be:{:ok, [ action_1_response, action_2_response, [action_3_response, action_4_response], action_5_response, ]}An error response depends on the type of pipeline. A sequence pipeline stops on first error, responding with {:error, reason}. A parallel pipeline waits for all the actions to finish. If any of them responded with an error, the aggregated response will be {:error, [error1, error2, ...]}.Note that in a nested pipeline, where the top-level element is a sequence, an error response can be {:error, action_error | [action_error]}. In addition, the list of errors might be nested. You can consider using functions such as List.wrap/1 and List.flatten/1 to convert the error(s) into a flat list.","ref":"Job.Pipeline.html","title":"Job.Pipeline","type":"module"},{"doc":"Returns a specification for running a parallel pipeline as a Job action.The corresponding action will return {:ok, [action_result]} | {:error, [action_error]} See Job.start_action/2 for details.","ref":"Job.Pipeline.html#parallel/2","title":"Job.Pipeline.parallel/2","type":"function"},{"doc":"Returns a specification for running a sequential pipeline as a Job action.The corresponding action will return {:ok, [action_result]} | {:error, action_error} See Job.start_action/2 for details.","ref":"Job.Pipeline.html#sequence/2","title":"Job.Pipeline.sequence/2","type":"function"},{"doc":"Error struct returned by various OsCmd operations.","ref":"OsCmd.Error.html","title":"OsCmd.Error","type":"exception"},{"doc":"","ref":"OsCmd.Error.html#t:t/0","title":"OsCmd.Error.t/0","type":"type"},{"doc":"CI CI/CD toolkit as an Elixir library.","ref":"readme.html","title":"CI","type":"extras"},{"doc":"Early alpha. Not tested in any serious production. Expect bugs and breaking changes.","ref":"readme.html#status","title":"CI - Status","type":"extras"},{"doc":"Job.run( Job.Pipeline.sequence([ mix(&quot;compile --warnings-as-errors&quot;), Job.Pipeline.parallel([ mix(&quot;dialyzer&quot;), mix(&quot;test&quot;), mix(&quot;format --check-formatted&quot;), mix(&quot;docs&quot;, env: [mix_env: &quot;dev&quot;]) ]) ]), timeout: :timer.minutes(10) ) |&gt; report_errors() defp mix(arg, opts \\\\ []), do: cmd(&quot;mix \#{arg}&quot;, Config.Reader.merge([env: [mix_env: &quot;test&quot;]], opts)) defp cmd(cmd, opts) do handler = &amp;IO.write(message(&amp;1, cmd)) cmd_opts = [handler: handler] ++ Keyword.merge([pty: true], opts) OsCmd.action(cmd, cmd_opts) end defp message(:starting, cmd), do: &quot;starting \#{cmd}\\n&quot; defp message({:output, output}, _cmd), do: output defp message({:stopped, status}, cmd), do: &quot;\#{cmd} stopped with reason \#{inspect(status)}&quot;This is the highest level API, which should fit simpler scenarios. For more involved needs, you can replace Job.Pipeline with imperative actions powered by Job. The example above can be also written as:Job.run(fn -&gt; with {:ok, _output} &lt;- Job.run_action(mix(&quot;compile --warnings-as-errors&quot;)) do [ mix(&quot;dialyzer&quot;), mix(&quot;test&quot;), mix(&quot;format --check-formatted&quot;), mix(&quot;docs&quot;, env: [mix_env: &quot;dev&quot;]) ] |&gt; Enum.map(&amp;Job.start_action/1) |&gt; Enum.map(&amp;Job.await/1) |&gt; interpret_results() end end)","ref":"readme.html#basic-example","title":"CI - Basic example","type":"extras"},{"doc":"Make sure the prerequisites are installed:Erlang &gt;= 23Elixir &gt;= 1.11go &gt;= 1.15Add CI as a dependency inside your mix.exs: # mix.exs defp deps do [ {:ci, &quot;~&gt; 0.1.0&quot;}, # ... ] endInvoke mix ci.initInvoke mix my_app.ci, replacing my_app with the name of your OTP app.The generated CI mix task will first compile the project, and then run mix test and mix format --check-formatted in parallel. Note that this task may fail if your project requires additional pre-test tasks, such as Ecto repo setup.You can optionally write a test that verifies your CI flow. See here for a simple example.To run these checks on some CI platform (Travis, Circle, GitHub Actions, ...), you need to make sure prerequisites are installed, and then invoke mix deps.get, followed by mix my_app.ci. You can see how this project is configured to test itself on GitHub Actions here.Alternatively, you can consider creating a separate mix project, which only contains the CI mix task. The benefit of this approach is that you can then move all the steps of the tested project inside the mix task. This can be useful if you e.g. need to perform some preparations before fetching deps (e.g. setup ssh credentials, etc).","ref":"readme.html#quick-start","title":"CI - Quick start","type":"extras"},{"doc":"CI is a collection of small standalone abstractions that can be useful beyond the CI domain:OsCmd - Managed execution of OS commandsJob - Managed execution of potentially failing actionsJob.Pipeline - a high-level interface for running sequential and parallel pipelines inside a jobExcept for the ci.init mix task, no special code exists in the Ci namespace. The generated client CI code merely combines the abstractions listed above to implement the desired CI flow in Elixir. Using a first-class language instead of an ad-hoc proprietary yaml-based DSL leads to the following benefits:Easy to learn If the project is developed in Elixir, everyone on the team is already mostly equipped with the necessary knowledge. Obviously you need to study the docs of the provided abstractions, so you can use them properly, but at least this doesn't require learning a completely different syntax, and the knowledge you gather may serve you beyond the CI domain.Flexible Write complex loops and branching logic. Declare variables and organize your code in functions for improved readability and/or reusability. Reap all the benefits of BEAM (support for concurrency and fault-tolerance), and its ecosystem. Note that despite being imperative first, CI makes it possible to use a full-declarative proprietary DSL. Converting e.g. a yaml or a json into a series of Job.Pipeline actions should be straightforward, and is left as an exercise for the reader :-) Being organized as toolkit, rather than a framework, this library leaves a lot of rooms for variations, without requiring a large amount of knobs. You can use only those abstractions that suit your purposes, combining them in whichever way you like. Since most of the code is organized in a porcelain/plumbing way, you can fall back one layer deeper in case you need to make different choices.Local-first Easily run the entire flow locally. Test and troubleshoot the problems without pushing commits to trigger an external build.Testable Write tests which exercise some critical parts of your CI/CD flow (e.g. a mail is sent on error, or system is deployed after all the checks have passed).Rich tooling Use all the tools from the BEAM ecosystem, such as IDE support, debuggers, profilers, ...","ref":"readme.html#explanation","title":"CI - Explanation","type":"extras"},{"doc":"[ ] Improve Windows support (help needed)[ ] Docker support (managing docker images, managed execution of docker containers)[ ] VCS wrappers (git, ...)[ ] SCM platform clients (e.g. reacting to GitHub events)","ref":"readme.html#roadmap","title":"CI - Roadmap","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"CI - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"first version","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"Copyright 2021, Saša Jurić Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]